// ****************************************************************************
// 
// WAV Tools
// Copyright (C) 2005  Moitah (moitah@yahoo.com)
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ****************************************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace WAVTools {
	public class frmWAVTools : System.Windows.Forms.Form {
		private System.Windows.Forms.TextBox txtOffset;
		private System.Windows.Forms.Label lblOffset;
		private System.Windows.Forms.Label lblOffsetSamples;
		private System.Windows.Forms.Button btnBrowseSource;
		private System.Windows.Forms.ListBox lstSource;
		private System.Windows.Forms.GroupBox grpSource;
		private System.Windows.Forms.GroupBox grpDest;
		private System.Windows.Forms.Button btnBrowseDest;
		private System.Windows.Forms.TextBox txtDest;
		private System.Windows.Forms.TextBox txtPreGap;
		private System.Windows.Forms.Label lblPreGap;
		private System.Windows.Forms.Label lblPreGapMSF;
		private System.Windows.Forms.Button btnRemove;
		private System.Windows.Forms.Button btnUp;
		private System.Windows.Forms.Button btnDown;
		private System.Windows.Forms.Button btnClear;
		private System.Windows.Forms.Button btnWrite;
		private System.ComponentModel.Container components = null;

		public frmWAVTools() {
			// Required for Windows Form Designer support
			InitializeComponent();

			// Add any constructor code here
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.btnWrite = new System.Windows.Forms.Button();
			this.txtOffset = new System.Windows.Forms.TextBox();
			this.lblOffset = new System.Windows.Forms.Label();
			this.lblOffsetSamples = new System.Windows.Forms.Label();
			this.grpSource = new System.Windows.Forms.GroupBox();
			this.btnBrowseSource = new System.Windows.Forms.Button();
			this.lstSource = new System.Windows.Forms.ListBox();
			this.grpDest = new System.Windows.Forms.GroupBox();
			this.btnBrowseDest = new System.Windows.Forms.Button();
			this.txtDest = new System.Windows.Forms.TextBox();
			this.txtPreGap = new System.Windows.Forms.TextBox();
			this.lblPreGap = new System.Windows.Forms.Label();
			this.lblPreGapMSF = new System.Windows.Forms.Label();
			this.btnRemove = new System.Windows.Forms.Button();
			this.btnUp = new System.Windows.Forms.Button();
			this.btnDown = new System.Windows.Forms.Button();
			this.btnClear = new System.Windows.Forms.Button();
			this.grpSource.SuspendLayout();
			this.grpDest.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnWrite
			// 
			this.btnWrite.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnWrite.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnWrite.Location = new System.Drawing.Point(536, 313);
			this.btnWrite.Name = "btnWrite";
			this.btnWrite.Size = new System.Drawing.Size(87, 23);
			this.btnWrite.TabIndex = 8;
			this.btnWrite.Text = "Make Image";
			this.btnWrite.Click += new System.EventHandler(this.btnJoin_Click);
			// 
			// txtOffset
			// 
			this.txtOffset.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.txtOffset.Location = new System.Drawing.Point(84, 313);
			this.txtOffset.Name = "txtOffset";
			this.txtOffset.Size = new System.Drawing.Size(48, 21);
			this.txtOffset.TabIndex = 3;
			this.txtOffset.Text = "0";
			// 
			// lblOffset
			// 
			this.lblOffset.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblOffset.AutoSize = true;
			this.lblOffset.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblOffset.Location = new System.Drawing.Point(8, 317);
			this.lblOffset.Name = "lblOffset";
			this.lblOffset.Size = new System.Drawing.Size(68, 17);
			this.lblOffset.TabIndex = 2;
			this.lblOffset.Text = "Write Offset:";
			// 
			// lblOffsetSamples
			// 
			this.lblOffsetSamples.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblOffsetSamples.AutoSize = true;
			this.lblOffsetSamples.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblOffsetSamples.Location = new System.Drawing.Point(140, 317);
			this.lblOffsetSamples.Name = "lblOffsetSamples";
			this.lblOffsetSamples.Size = new System.Drawing.Size(45, 17);
			this.lblOffsetSamples.TabIndex = 4;
			this.lblOffsetSamples.Text = "samples";
			// 
			// grpSource
			// 
			this.grpSource.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpSource.Controls.Add(this.btnClear);
			this.grpSource.Controls.Add(this.btnDown);
			this.grpSource.Controls.Add(this.btnUp);
			this.grpSource.Controls.Add(this.btnRemove);
			this.grpSource.Controls.Add(this.btnBrowseSource);
			this.grpSource.Controls.Add(this.lstSource);
			this.grpSource.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.grpSource.Location = new System.Drawing.Point(8, 4);
			this.grpSource.Name = "grpSource";
			this.grpSource.Size = new System.Drawing.Size(615, 242);
			this.grpSource.TabIndex = 0;
			this.grpSource.TabStop = false;
			this.grpSource.Text = "Source Files:";
			// 
			// btnBrowseSource
			// 
			this.btnBrowseSource.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowseSource.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseSource.Location = new System.Drawing.Point(528, 18);
			this.btnBrowseSource.Name = "btnBrowseSource";
			this.btnBrowseSource.TabIndex = 1;
			this.btnBrowseSource.Text = "Add...";
			this.btnBrowseSource.Click += new System.EventHandler(this.btnBrowseSource_Click);
			// 
			// lstSource
			// 
			this.lstSource.AllowDrop = true;
			this.lstSource.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstSource.IntegralHeight = false;
			this.lstSource.Location = new System.Drawing.Point(12, 18);
			this.lstSource.Name = "lstSource";
			this.lstSource.Size = new System.Drawing.Size(508, 212);
			this.lstSource.TabIndex = 0;
			this.lstSource.DragDrop += new System.Windows.Forms.DragEventHandler(this.lstSource_DragDrop);
			this.lstSource.DragEnter += new System.Windows.Forms.DragEventHandler(this.SharedDragEnter);
			// 
			// grpDest
			// 
			this.grpDest.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grpDest.Controls.Add(this.btnBrowseDest);
			this.grpDest.Controls.Add(this.txtDest);
			this.grpDest.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.grpDest.Location = new System.Drawing.Point(8, 250);
			this.grpDest.Name = "grpDest";
			this.grpDest.Size = new System.Drawing.Size(615, 53);
			this.grpDest.TabIndex = 1;
			this.grpDest.TabStop = false;
			this.grpDest.Text = "Destination File:";
			// 
			// btnBrowseDest
			// 
			this.btnBrowseDest.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowseDest.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnBrowseDest.Location = new System.Drawing.Point(528, 18);
			this.btnBrowseDest.Name = "btnBrowseDest";
			this.btnBrowseDest.TabIndex = 1;
			this.btnBrowseDest.Text = "Browse...";
			this.btnBrowseDest.Click += new System.EventHandler(this.btnBrowseDest_Click);
			// 
			// txtDest
			// 
			this.txtDest.AllowDrop = true;
			this.txtDest.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtDest.Location = new System.Drawing.Point(12, 18);
			this.txtDest.Name = "txtDest";
			this.txtDest.Size = new System.Drawing.Size(508, 21);
			this.txtDest.TabIndex = 0;
			this.txtDest.Text = "";
			this.txtDest.DragDrop += new System.Windows.Forms.DragEventHandler(this.txtDest_DragDrop);
			this.txtDest.DragEnter += new System.Windows.Forms.DragEventHandler(this.SharedDragEnter);
			// 
			// txtPreGap
			// 
			this.txtPreGap.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.txtPreGap.Location = new System.Drawing.Point(294, 313);
			this.txtPreGap.Name = "txtPreGap";
			this.txtPreGap.Size = new System.Drawing.Size(60, 21);
			this.txtPreGap.TabIndex = 6;
			this.txtPreGap.Text = "00:00:00";
			// 
			// lblPreGap
			// 
			this.lblPreGap.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblPreGap.AutoSize = true;
			this.lblPreGap.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblPreGap.Location = new System.Drawing.Point(216, 317);
			this.lblPreGap.Name = "lblPreGap";
			this.lblPreGap.Size = new System.Drawing.Size(71, 17);
			this.lblPreGap.TabIndex = 5;
			this.lblPreGap.Text = "Add Pre-Gap:";
			// 
			// lblPreGapMSF
			// 
			this.lblPreGapMSF.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblPreGapMSF.AutoSize = true;
			this.lblPreGapMSF.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblPreGapMSF.Location = new System.Drawing.Point(362, 317);
			this.lblPreGapMSF.Name = "lblPreGapMSF";
			this.lblPreGapMSF.Size = new System.Drawing.Size(54, 17);
			this.lblPreGapMSF.TabIndex = 7;
			this.lblPreGapMSF.Text = "MM:SS:FF";
			// 
			// btnRemove
			// 
			this.btnRemove.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnRemove.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnRemove.Location = new System.Drawing.Point(528, 88);
			this.btnRemove.Name = "btnRemove";
			this.btnRemove.TabIndex = 3;
			this.btnRemove.Text = "Remove";
			this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
			// 
			// btnUp
			// 
			this.btnUp.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnUp.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnUp.Location = new System.Drawing.Point(528, 116);
			this.btnUp.Name = "btnUp";
			this.btnUp.TabIndex = 4;
			this.btnUp.Text = "Up";
			this.btnUp.Click += new System.EventHandler(this.btnUp_Click);
			// 
			// btnDown
			// 
			this.btnDown.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDown.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnDown.Location = new System.Drawing.Point(528, 144);
			this.btnDown.Name = "btnDown";
			this.btnDown.TabIndex = 5;
			this.btnDown.Text = "Down";
			this.btnDown.Click += new System.EventHandler(this.btnDown_Click);
			// 
			// btnClear
			// 
			this.btnClear.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClear.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnClear.Location = new System.Drawing.Point(528, 60);
			this.btnClear.Name = "btnClear";
			this.btnClear.TabIndex = 2;
			this.btnClear.Text = "Clear";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// frmWAVTools
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(631, 344);
			this.Controls.Add(this.lblPreGapMSF);
			this.Controls.Add(this.lblPreGap);
			this.Controls.Add(this.txtPreGap);
			this.Controls.Add(this.grpDest);
			this.Controls.Add(this.grpSource);
			this.Controls.Add(this.lblOffsetSamples);
			this.Controls.Add(this.lblOffset);
			this.Controls.Add(this.txtOffset);
			this.Controls.Add(this.btnWrite);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.MinimumSize = new System.Drawing.Size(639, 371);
			this.Name = "frmWAVTools";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "WAV Tools";
			this.Load += new System.EventHandler(this.frmWAVTools_Load);
			this.Closed += new System.EventHandler(this.frmWAVTools_Closed);
			this.grpSource.ResumeLayout(false);
			this.grpDest.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new frmWAVTools());
		}

		private void frmWAVTools_Load(object sender, System.EventArgs e) {
			LoadSettings();
		}

		private void frmWAVTools_Closed(object sender, System.EventArgs e) {
			SaveSettings();
		}

		private void btnBrowseSource_Click(object sender, System.EventArgs e) {
			OpenFileDialog fileDlg = new OpenFileDialog();
			DialogResult dlgRes;

			fileDlg.Title = "Source WAVs";
			fileDlg.Filter = "WAV Files (*.wav)|*.wav";
			fileDlg.Multiselect = true;

			dlgRes = fileDlg.ShowDialog();
			if (dlgRes == DialogResult.OK) {
				string[] paths = fileDlg.FileNames;
				Array.Sort(paths);
				lstSource.Items.AddRange(paths);
			}
		}

		private void btnBrowseDest_Click(object sender, System.EventArgs e) {
			SaveFileDialog fileDlg = new SaveFileDialog();
			DialogResult dlgRes;

			fileDlg.Title = "Destination WAV";
			fileDlg.Filter = "WAV Files (*.wav)|*.wav";

			dlgRes = fileDlg.ShowDialog();
			if (dlgRes == DialogResult.OK) {
				txtDest.Text = fileDlg.FileName;
			}
		}

		private void SharedDragEnter(object sender, System.Windows.Forms.DragEventArgs e) {
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) {
				e.Effect = DragDropEffects.Copy;
			}
		}

		private void lstSource_DragDrop(object sender, System.Windows.Forms.DragEventArgs e) {
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) {
				string[] paths = (string[])e.Data.GetData(DataFormats.FileDrop);
				Array.Sort(paths);
				for (int i = 0; i < paths.Length; i++) {
					if (File.Exists(paths[i])) {
						lstSource.Items.Add(paths[i]);
					}
				}
			}
		}

		private void txtDest_DragDrop(object sender, System.Windows.Forms.DragEventArgs e) {
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) {
				string[] paths = (string[])e.Data.GetData(DataFormats.FileDrop);
				if (paths.Length == 1) {
					txtDest.Text = paths[0];
				}
			}
		}

		private void btnClear_Click(object sender, System.EventArgs e) {
			lstSource.Items.Clear();
		}

		private void btnRemove_Click(object sender, System.EventArgs e) {
			int s = lstSource.SelectedIndex;
			int count = lstSource.Items.Count - 1;
			if (s != -1) {
				lstSource.Items.RemoveAt(s);
				if (count != 0) {
					lstSource.SelectedIndex = Math.Min(s, count - 1);
				}
			}
		}

		private void btnUp_Click(object sender, System.EventArgs e) {
			int s = lstSource.SelectedIndex;
			if ((s != -1) && (s != 0)) {
				ListBoxSwapItems(lstSource, s, s - 1);
				lstSource.SelectedIndex = s - 1;
			}
		}

		private void btnDown_Click(object sender, System.EventArgs e) {
			int s = lstSource.SelectedIndex;
			if ((s != -1) && (s != lstSource.Items.Count - 1)) {
				ListBoxSwapItems(lstSource, s, s + 1);
				lstSource.SelectedIndex = s + 1;
			}
		}

		private void btnJoin_Click(object sender, System.EventArgs e) {
			const int samplesPerFrame = 588;
			string[] src;
			string dst;
			int offset, preGap, addStart, addEnd, remStart, remEnd;

			if (lstSource.Items.Count == 0) {
				MessageBox.Show("You must add source files.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			src = new string[lstSource.Items.Count];
			lstSource.Items.CopyTo(src, 0);

			dst = txtDest.Text.Trim();
			if (dst.Length == 0) {
				MessageBox.Show("You must select a destination file.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			try {
				offset = Int32.Parse(txtOffset.Text);
			}
			catch {
				MessageBox.Show("Invalid write offset.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			try {
				preGap = MSFToFrames(txtPreGap.Text) * samplesPerFrame;
			}
			catch {
				MessageBox.Show("Invalid pre-gap length.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			if (offset >= 0) {
				int adjPreGap = preGap - offset;
				addStart = Math.Max(adjPreGap, 0);
				remStart = Math.Max(-adjPreGap, 0);
				addEnd = offset;
				remEnd = 0;
			}
			else {
				addStart = -offset + preGap;
				remStart = 0;
				addEnd = 0;
				remEnd = -offset;
			}

			try {
				JoinWAVs(src, dst, addStart, addEnd, remStart, remEnd);
			}
			catch (Exception ex) {
				MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			MessageBox.Show("Image was written successfully.", "Finished", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void JoinWAVs(string[] pathIn, string pathOut, int addStart, int addEnd, int remStart, int remEnd) {
			const int buffSamplesMax = 16384;
			WAVReader[] wrList;
			WAVReader wr;
			WAVWriter ww;
			byte[] buff;
			int i, inputSampleCount, skipRemaining, copyRemaining;

			wrList = new WAVReader[pathIn.Length];
			inputSampleCount = 0;

			for (i = 0; i < wrList.Length; i++) {
				wr = new WAVReader(pathIn[i]);
				if ((wr.BitsPerSample != 16) || (wr.ChannelCount != 2) || (wr.SampleRate != 44100)) {
					throw new Exception("Source WAV must be CD format.");
				}
				inputSampleCount += (int)wr.Length;

				wrList[i] = wr;
			}

			ww = new WAVWriter(pathOut, 16, 2, 44100);
			buff = new byte[buffSamplesMax * 4];
			skipRemaining = remStart;
			copyRemaining = inputSampleCount - (remStart + remEnd);

			WriteSilence(ww, addStart);

			for (i = 0; i < wrList.Length; i++) {
				wr = wrList[i];

				while ((wr.Remaining > 0) && (copyRemaining > 0)) {
					if (skipRemaining > 0) {
						int skipCount = Math.Min(skipRemaining, (int)wr.Remaining);
						wr.Position = skipCount;
						skipRemaining -= skipCount;
					}
					else {
						int copyCount = Math.Min(buffSamplesMax, Math.Min(copyRemaining, (int)wr.Remaining));
						wr.Read(buff, copyCount);
						ww.Write(buff, copyCount);
						copyRemaining -= copyCount;
					}
				}

				wr.Close();
			}

			WriteSilence(ww, addEnd);

			ww.Close();
		}

		private void WriteSilence(WAVWriter ww, int sampleCount) {
			const int buffSamplesMax = 1024;
			byte[] buff = new byte[buffSamplesMax * 4];
			int writeCount;

			while (sampleCount > 0) {
				writeCount = Math.Min(sampleCount, buffSamplesMax);
				ww.Write(buff, writeCount);
				sampleCount -= writeCount;
			}
		}

		private int MSFToFrames(string msf) {
			const int framesPerSec = 75;
			string[] split = msf.Split(':');
			int m, s, f;

			if (split.Length != 3) {
				throw new Exception("Invalid MSF string.");
			}

			try {
				m = Int32.Parse(split[0]);
				s = Int32.Parse(split[1]);
				f = Int32.Parse(split[2]);
			}
			catch {
				throw new Exception("Invalid MSF string.");
			}

			return (((m * 60) + s) * framesPerSec) + f;
		}

		private void ListBoxSwapItems(ListBox listBox, int a, int b) {
			object temp = listBox.Items[a];
			listBox.Items[a] = listBox.Items[b];
			listBox.Items[b] = temp;
		}

		private string GetConfigPath() {
			return Path.Combine(Application.StartupPath, "config.txt");
		}

		private void SaveSettings() {
			string path = GetConfigPath();
			StreamWriter sw = new StreamWriter(path, false, System.Text.Encoding.ASCII);

			sw.WriteLine("WriteOffset: " + txtOffset.Text);

			sw.Close();
		}

		private void LoadSettings() {
			string path = GetConfigPath();
			if (!File.Exists(path)) {
				return;
			}
			StreamReader sr = new StreamReader(path, System.Text.Encoding.ASCII);
			string line, name, val;
			int x;

			while ((line = sr.ReadLine()) != null) {
				x = line.IndexOf(':');
				if (x != -1) {
					name = line.Substring(0, x);
					val = line.Substring(x + 2);

					switch (name) {
						case "WriteOffset":
							txtOffset.Text = val;
							break;
					}
				}
			}

			sr.Close();
		}
	}
}